#!/usr/bin/env python
#!/usr/bin/python
#
### ViaLactea DATA MINING TOOLS
#
# match.py
# routines to produce C3 output
#
# Author: G. Riccio
# Creation Date: March 1, 2016
# Release: 1.0
# Release Date: July 23, 2016
#
# Copyright 2016, Giuseppe Riccio, Massimo Brescia
# This file is part of C3.

    # C3 is free software: you can redistribute it and/or modify
    # it under the terms of the GNU General Public License as published by
    # the Free Software Foundation, either version 3 of the License, or
    # (at your option) any later version.

    # C3 is distributed in the hope that it will be useful,
    # but WITHOUT ANY WARRANTY; without even the implied warranty of
    # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    # GNU General Public License for more details.

    # You should have received a copy of the GNU General Public License
    # along with C3.  If not, see <http://www.gnu.org/licenses/>.
#
### WINDOWS INSTRUCTIONS
#
# This program has been produced with python 2.7.8 (64bit)
# It has been tested on Windows 7 and 10, by running it in a system
# shell window.
#
# IMPORTANT: be sure to have previously installed python 2.7.8
# 64-bit version
#
### LINUX UBUNTU INSTRUCTIONS
#
# This program has been tested on Linux Ubuntu 14.04 with python 2.7.6 (64-bit)
#
#################

# import needed libraries
from 	libs.ioUtils         	import setOutDir
from 	os			import sep, system, path
import 	csv
import 	numpy as np
from 	libs.utility 		import getDistCase



def runRowByRow(file1tmp, rows1, file2tmp, rows2, header1, header2, outputFile):

	outdir, outfile=setOutDir(outputFile)
	header=header1+","+header2+"\n"
	with open(outputFile, 'w') as f:
		f.write(header)
		for i in range(0, len(rows1)):
			f.write(rows1[i].strip("\r\n")+","+rows2[i].strip("\r\n")+"\n")		
	

def createOutput(tmp_path, stiltsDir, outputFile, outformat, n, logfile, rows1,rows2, criteria, outdata):


	# Define vars
	n_matches=0
	sel=outdata[0]
	join=outdata[1]
	header1=outdata[2]
	header2=outdata[3]

	des1=outdata[4]
	des2=outdata[5]

	if outformat=="csv" or outformat=="ascii":
		tmpfile=outputFile
	else:
		tmpfile=tmp_path+sep+"temp.csv"


	# Create and store HEADER
	cases=getDistCase()	
	distRow=0
	if join not in cases or criteria != "sky":
		final_s="\n"
	else:
		final_s=",Separation\n"
		distRow=1

	if des1==-1:
		header1="ROW_ID1,"+header1
	if des2==-1:
		header2="ROW_ID2,"+header2

	writehead(join, header1, header2, final_s, tmpfile, outformat)

	


	if sel=="all":
		cat1,cat2,dist=createAll(tmp_path, n, distRow)


	elif sel=="best":
		cat1,cat2,dist=createBest(tmp_path, n, distRow)







	# Create arrays of matches ID
	
#	cat1=np.array([], dtype=int)
#	cat2=np.array([], dtype=int)
#	dist=np.array([])

#	i=0
#	while i<n:
#		inputfile=setMatchFile(sel, tmp_path, i)
#		if path.isfile(inputfile):
#			f1=open(inputfile, "r")
#			f1.readline()  									#skip header
			
#			line=f1.readline()
			
#BUG CASE ALL
#			while line!="":
#				cat_str=line.split(",")
#				c2_val=int(cat_str[1])
#				isIn=np.where(cat2==c2_val)[0]
##				isIn=np.where(cat2==c2_val)[0]
##				if len(isIn)==0:					#object of cat2 is not yet matched
##					cat1=np.append(cat1,int(cat_str[0]))
##					cat2=np.append(cat2,int(cat_str[1]))
##					if distRow==1:
##						dist=np.append(dist,cat_str[2])
##				
##				else:
##					if distRow==1:
##						dist_old=float(dist[isIn[0]])
##						dist_new=float(cat_str[2])
##
##						if dist_new<dist_old:
##							cat1[isIn[0]]=int(cat_str[0])
##							cat2[isIn[0]]=int(cat_str[1])							
##							dist[isIn[0]]=dist_new


#				if len(isIn)>0:					#object of cat2 is not yet matched
#					if distRow==1:
						
#						dist_old=float(dist[isIn[0]])
#						dist_new=float(cat_str[2])
#						if dist_new<dist_old:
#							cat1[isIn[0]]=int(cat_str[0])
#							cat2[isIn[0]]=int(cat_str[1])							
#							dist[isIn[0]]=dist_new
#				
#				else:
#					cat1=np.append(cat1,int(cat_str[0]))
#					cat2=np.append(cat2,int(cat_str[1]))
#					if distRow==1:
#						dist=np.append(dist,cat_str[2])
#					
#
#				line=f1.readline()
#
#		i+=1

	

	n_matches=saveOutput(cat1, cat2, dist, rows1, rows2, distRow, tmpfile, des1, des2, join, outformat)

	
	if n_matches>0:
		if outformat!="csv" and outformat!="ascii":
			cmd="java -jar "+stiltsDir+"stilts.jar tcopy "+tmpfile+" "+outputFile+" ifmt=csv ofmt="+outformat 
			system(cmd)
	else:
		with open(outputFile+".txt","w") as f:
			f.write("No matches found.")		

	return n_matches



def createBest(tmp_path, n, distRow):

	cat1=np.array([], dtype=int)
	cat2=np.array([], dtype=int)
	dist=np.array([])

	i=0
	while i<n:
		inputfile=setBestMatchFile(tmp_path, i)
		if path.isfile(inputfile):
			f1=open(inputfile, "r")
			f1.readline()  									#skip header
			
			line=f1.readline()
			
#BUG CASE ALL
			while line!="":
				cat_str=line.split(",")
				c2_val=int(cat_str[1])
				isIn=np.where(cat2==c2_val)[0]
				if len(isIn)>0:					#object of cat2 is not yet matched
					if distRow==1:
						
						dist_old=float(dist[isIn[0]])
						dist_new=float(cat_str[2])
						if dist_new<dist_old:
							cat1[isIn[0]]=int(cat_str[0])
							cat2[isIn[0]]=int(cat_str[1])							
							dist[isIn[0]]=dist_new
				
				else:
					cat1=np.append(cat1,int(cat_str[0]))
					cat2=np.append(cat2,int(cat_str[1]))
					if distRow==1:
						dist=np.append(dist,cat_str[2])
					

				line=f1.readline()

		i+=1



	return cat1,cat2,dist



def createAll(tmp_path, n, distRow):

	cat1=[]
	cat2=[]
	dist=[]
	i=0
	while i<n:
		inputfile=tmp_path+sep+str(i)+".csv"
		if path.isfile(inputfile):
			f1=open(inputfile, "r")
			f1.readline()  									#skip header
	
			line=f1.readline()
			while line!="":
				cat_str=line.split(",")
				cat1.append(int(cat_str[0]))
				cat2.append(int(cat_str[1]))
				if distRow==1:
					dist.append(cat_str[2])		

				line=f1.readline()


		i+=1

	return cat1,cat2,dist



def saveOutput(cat1, cat2, dist, rows1, rows2, distRow, outputFile, des1, des2, join, outformat):

	nrowsMatch=0
	nrowsNoMatch1=0
	nrowsNoMatch2=0
	lRows1=len(rows1[0].split(","))
	lRows2=len(rows2[0].split(","))	

	if join=="1 and 2":
		nrowsMatch=matches(cat1, cat2, dist, rows1, rows2, distRow, outputFile, des1, des2, outformat)

	elif join=="1 or 2":
		nrowsMatch=matches(cat1, cat2, dist, rows1, rows2, distRow, outputFile, des1, des2, outformat)
		nrowsNoMatch1=notMatches(cat1, rows1, outputFile, des1, des2, 1, lRows2, join, outformat, distRow)
		nrowsNoMatch2=notMatches(cat2, rows2, outputFile, des2, des1, 2, lRows1, join, outformat, distRow)
	
	elif join=="all from 1":
		nrowsMatch=matches(cat1, cat2, dist, rows1, rows2, distRow, outputFile, des1, des2, outformat)
		nrowsNoMatch1=notMatches(cat1, rows1, outputFile, des1, des2, 1, lRows2, join, outformat, distRow)
		
	elif join=="all from 2":
		nrowsMatch=matches(cat1, cat2, dist, rows1, rows2, distRow, outputFile, des1, des2, outformat)
		nrowsNoMatch2=notMatches(cat2, rows2, outputFile, des2, des1, 2, lRows1, join, outformat, distRow)

	elif join=="1 not 2":
		nrowsNoMatch1=notMatches(cat1, rows1, outputFile, des1, des2, 1, lRows2, join, outformat, distRow)

	elif join=="2 not 1":
		nrowsNoMatch2=notMatches(cat2, rows2, outputFile, des2, des1, 2, lRows1, join, outformat, distRow)

	elif join=="1 xor 2":
		nrowsNoMatch1=notMatches(cat1, rows1, outputFile, des1, des2, 1, lRows2, join, outformat, distRow)
		nrowsNoMatch2=notMatches(cat2, rows2, outputFile, des2, des1, 2, lRows1, join, outformat, distRow)
	


	nrows=nrowsMatch+nrowsNoMatch1+nrowsNoMatch2
	return nrows



def matches(cat1, cat2, dist, rows1, rows2, distRow, out, des1, des2, outformat):

	nrows=len(cat1)

	f=open(out,"a")
	for i in range(0,len(cat1)):

			

		#SAVE ROW_ID IF DESIGNATION IS MISSING
		if des1==-1:
			a=str(cat1[i]+1)+","+rows1[cat1[i]].strip()
		else:
			a=rows1[cat1[i]].strip()

		if des2==-1:
			b=str(cat2[i]+1)+","+rows2[cat2[i]].strip()
		else:
			b=rows2[cat2[i]].strip()


		#SAVE DISTANCE IF PRESENT		
		if distRow==1:
			c=dist[i].strip()

			stringa=a+","+b+","+c+"\n"
		else:
			stringa=a+","+b+"\n"

		if outformat=="ascii":
			stringa="'"+stringa.replace(",","' '").replace("\n","'\n")

		f.write(stringa)

	f.close()	
	return nrows


def notMatches(cat, rows, out, des, desOther, catnum, lenOther, join, outformat, distRow):

	nrows=0
	f=open(out,"a")
	for i in range(0,len(rows)):
		
		if i not in cat:
			if des==-1:
				a=str(i+1)+","+rows[i].strip()
			else:
				a=rows[i].strip()

			if join!="1 not 2" and join!="2 not 1":
				void=createVoid(lenOther, desOther)
			else:
				void=""

			if distRow==1:
				final=",\n"
			else:
				final="\n"

			if catnum==1:
				stringa=a+void+final
			elif catnum==2:
				stringa=void+a+final
						

			nrows+=1
			f.write(stringa)

	f.close()	
	return nrows



def createVoid(l,des):

	if des==-1:
		l=l+1
	void=""
	i=0
	while i<=l:
		void=void+","
		i+=1
	
	void=void[:-1]
	return void


def writehead(join, header1, header2, final_s, outputFile, outformat):


	if join=="1 and 2":
		header=header1+","+header2+final_s

	elif join=="1 or 2":
		header=header1+","+header2+final_s

	elif join=="all from 1":
		header=header1+","+header2+final_s

	elif join=="all from 2":
		header=header1+","+header2+final_s

	elif join=="1 not 2":
		header=header1+"\n"

	elif join=="2 not 1":
		header=header2+"\n"

	elif join=="1 xor 2":
		header=header1+","+header2+"\n"

	out=open(outputFile,"w")
	if outformat=="ascii":
		header="# "+header.replace(","," ")

	out.write(header)
	out.close()



def setMatchFile(sel, tmp_path, n):

	if sel=="all":
		inputfile=tmp_path+sep+str(n)+".csv"
	elif sel=="best":
		inputfile=setBestMatchFile(tmp_path, n)
	return inputfile



def setBestMatchFile(tmp_path, n):			#MIGLIORARE SENZA CREARE NUOVI ARRAY (WHILE INVECE DI FOR)

	matchfile=tmp_path+sep+str(n)+".csv"
	outputfile=tmp_path+sep+str(n)+"_best.csv"
	if path.isfile(matchfile):
		f1=open(matchfile,"r")
		reader = csv.DictReader(f1)
		header=reader.fieldnames
		head=""
		for h in header:
			head=head+str(h)+","
		head=head[:-1]+"\n"
		cat1=[]
		cat2=[]
		dist=[]
		string1=[]
		string2=[]
		final=""	

		for r in reader:
			cat1=cat1+[r['col1']]
			cat2=cat2+[r['col2']]
			if len(header)>=3:
				dist=dist+[r['col3']]



#		if len(header)>=5:
#			dist=dist+[r['col5']]
##		string1=string1+[r['col3']]	
#		string2=string2+[r['col4']]
	
		cat1=np.array(cat1)
		cat2=np.array(cat2)
		dist=np.array(dist)
#	string1=np.array(string1)
#	string2=np.array(string2)

		f2=open(outputfile,"w")
		f2.write(head)
	
		if len(header)<3:
	
			setBestExact(cat1, cat2, f2)			
		else:
			setBestSky(cat1, cat2, f2, dist)
	
#	if len(header)<5:				#NO SEPARATION COLUMN => EXACT VALUE
#		setBestExact(cat1, cat2, string1, string2,f2)
#	else:						# HAS SEPARATION COLUMN => SKY
#		setBestSky(cat1, cat2, string1, string2, f2, dist)

		f2.close()
		f1.close()

	return outputfile

def setBestExact(cat1, cat2, f2):
	best1, indices = np.unique(cat1, return_index=True)
	best2=cat2[indices]

	for i in range(0, len(best1)):
		res=best1[i]+","+best2[i]+"\n"
		f2.write(res)
	


def setBestSky(cat1, cat2, f2, distarray):


	arr=np.unique(cat1)
	cat1_new=[]
	cat2_new=[]
	dist_new=[]
#	string1_new=[]
#	string2_new=[]
	dist=np.array(distarray)
	for i in range(0,len(arr)):
		ind=arr[i]
		where_obj=np.where(cat1==ind)[0]
		distmin=999999
		indmin=9999
		for j in range(0, len(where_obj)):
			separ=float(dist[where_obj[j]])
			if separ<distmin:
				distmin=separ
				indmin=where_obj[j]
		cat2_new.append(cat2[indmin])
		cat1_new.append(cat1[indmin])
		dist_new.append(dist[indmin])


#		string1_new.append(string1[indmin])
#		string2_new.append(string2[indmin])


	cat1_new=np.array(cat1_new)
	cat2_new=np.array(cat2_new)
	dist_new=np.array(dist_new)
#	string1_new=np.array(string1_new)
#	string2_new=np.array(string2_new)

	cat2_final=[]
	cat1_final=[]
	dist_final=[]
	string1_final=[]
	string2_final=[]

	arr2=np.unique(cat2_new)

	for i in range(0,len(arr2)):
		ind=arr2[i]
		where_obj=np.where(cat2_new==ind)[0]
	
		distmin=999999
		indmin=9999
		for j in range(0, len(where_obj)):
			separ=float(dist_new[where_obj[j]])
			if separ<distmin:
				distmin=separ
				indmin=where_obj[j]
		cat2_final.append(cat2_new[indmin])
		cat1_final.append(cat1_new[indmin])
		dist_final.append(dist_new[indmin])
#		string1_final.append(string1_new[indmin])
#		string2_final.append(string2_new[indmin])

	
	for i in range(0, len(cat1_final)):
		res=cat1_final[i]+","+cat2_final[i]+","+dist_final[i]+"\n"
		#res=cat1_final[i]+","+cat2_final[i]+","+string1_final[i]+","+string2_final[i]+","+dist_final[i]+"\n"
		f2.write(res)





