#!/usr/bin/env python

#
### ViaLactea DATA MINING TOOLS
#
# threadExact.py
# function library to create threads to perform the C3 Exact Value associations
#
# Authors: G. Riccio
# Creation Date: May 26, 2015
# Release: 1.0
# Release Date: July 23, 2016
#
# Copyright 2016, Giuseppe Riccio, Massimo Brescia
# This file is part of C3.

    # C3 is free software: you can redistribute it and/or modify
    # it under the terms of the GNU General Public License as published by
    # the Free Software Foundation, either version 3 of the License, or
    # (at your option) any later version.

    # C3 is distributed in the hope that it will be useful,
    # but WITHOUT ANY WARRANTY; without even the implied warranty of
    # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    # GNU General Public License for more details.

    # You should have received a copy of the GNU General Public License
    # along with C3.  If not, see <http://www.gnu.org/licenses/>.
#
### WINDOWS INSTRUCTIONS
#
# This program has been produced with python 2.7.8 (64bit)
# It has been tested on Windows 7 and 8pro, by running it in a system
# shell window.
#
# IMPORTANT: be sure to have previously installed python 2.7.8
# 64-bit version
#
### LINUX UBUNTU INSTRUCTIONS
#
# This program has been tested on Linux Ubuntu 14.04 with python 2.7.6 (64-bit)
#
#################


# import needed libraries

import  threading
import  time
from    os              import sep, system, path
from    libs.utility         import assignPart
from    math            import sqrt, floor, ceil
import csv
import sys
import 	numpy 	as np
from 	multiprocessing import Process, Queue, cpu_count
import 	warnings

      
def execution(procID,tmp_path,n_threads):
#	set_globvar(col1,col2,selection,join,tmp_path, n_threads)

	f1=open(tmp_path+sep+"group"+str(procID),"r")
	f2=open(tmp_path+sep+"cat2exact.csv","r")
	outmatch=open(tmp_path+sep+str(procID)+".csv","w")
	outmatch.write("col1,col2\n")

	rows2=np.array(f2.readlines())
	row1=f1.readline().split(",")

	ind1=row1[0]
	val1=row1[1]

	while val1!="":
		a=np.where(val1==rows2)[0]
		if len(a)!=0:
			for i in range(len(a)):
				res=str(ind1)+","+str(a[i])+"\n"	
				outmatch.write(res)
		try:
			row1=f1.readline().split(",")
			ind1=row1[0]
			val1=row1[1]
		except:
			val1=""


	f1.close()
	f2.close()
	outmatch.close()



def exactRun(n_threads, tmp_path):
#	warnings.filterwarnings("ignore")		#SUPPRESSED WARNING BY np.array_split() in case of void row_group

	jobs=[]
	for i in range(n_threads):

		proc=Process(target=execution, args=(i,tmp_path,n_threads,))
		proc.start()
		jobs.append(proc)		


	
	for j in jobs:
		j.join()	







