#!/usr/bin/env python
#!/usr/bin/python
#
# prematch.py
# routine to prepare catalogues to C3 cross-match
#
# Author: G. Riccio
# Creation Date: March 1, 2016
# Release: 1.0
# Release Date: July 23, 2016
#
# Copyright 2016, Giuseppe Riccio, Massimo Brescia
# This file is part of C3.

    # C3 is free software: you can redistribute it and/or modify
    # it under the terms of the GNU General Public License as published by
    # the Free Software Foundation, either version 3 of the License, or
    # (at your option) any later version.

    # C3 is distributed in the hope that it will be useful,
    # but WITHOUT ANY WARRANTY; without even the implied warranty of
    # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    # GNU General Public License for more details.

    # You should have received a copy of the GNU General Public License
    # along with C3.  If not, see <http://www.gnu.org/licenses/>.
#
### WINDOWS INSTRUCTIONS
#
# This program has been produced with python 2.7.8 (64bit)
# It has been tested on Windows 7 and 10, by running it in a system
# shell window.
#
# IMPORTANT: be sure to have previously installed python, together with the following external packages:
#
# 	numpy;
#	pyfits;
#
### LINUX UBUNTU INSTRUCTIONS
#
# This program has been tested on Linux Ubuntu 14.04 with python 2.7.6 (64-bit)
#
#################
# SYNOPSIS
#
# The routin loads input catalogue in memory, convert coordinates and split datasets.
#
###################

from 	os 			import sep, system, path
import  csv
import  re
from 	libs.utility 		import writeLogFile,errorExit
from 	sys			import argv, stdout
from 	libs.prePhase		import createSubDiv, splitRows,convertCoords
from    math	    		import ceil


filename=argv[1]
coordsys=argv[2]
units=argv[3]
id_col=int(argv[4])
coord1_col=int(argv[5])
coord2_col=int(argv[6])
tmp_path=argv[7]
stiltsDir=argv[8]
logfile=argv[9]
maxAreaSize=float(argv[10])
l=int(argv[11])

f=open(filename,"r")
header=f.readline().replace("\n","").replace("\r","")
header_cols=header.split(",")

c1=header_cols[coord1_col]
c2=header_cols[coord2_col]


convertCoords(filename, coordsys, units, 2, tmp_path, c1, c2, stiltsDir,logfile)

fcoord=open(tmp_path+sep+"coord_cat2.csv", "r")
headcoord=fcoord.readline()

counts=int(l/10)
n=1
r=f.readline()
newrows=[]
i=0

while r!="":
	

	newr=r.rstrip("\n")
	row=newr.split(",")

	if id_col>=0:				#get ID
		C_ID=row[id_col]
	else:
		C_ID=i+1

	coord1=row[coord1_col]
	coord2=row[coord2_col]

	coords=fcoord.readline().split(",")
	l=float(coords[0])
	b=float(coords[1].rstrip("\n"))
	
	
	if id_col<0:
		newr=str(C_ID)+","+newr
	else:
		newr=newr

	if i==0:
		lmin=l
		lmax=l
		bmin=b
		bmax=b
	else:
		if l<lmin:
			lmin=l
		if l>lmax:
			lmax=l
		if b<bmin:
			bmin=b
		if b>bmax:
			bmax=b
						
	newstring=[newr,l,b]
	newrows.append(newstring)
	
	


	if i==counts*n:		
		stdout.write(".")
		stdout.flush()
		n+=1
	r=f.readline()
	i+=1
f.close()

#INSERIRE LMAX*FWHMMAX....
lmin=lmin-maxAreaSize/7200
lmax=lmax+maxAreaSize/7200
bmin=bmin-maxAreaSize/7200
bmax=bmax+maxAreaSize/7200


if lmax>=360 or lmin<=0:
	lmax=360
	lmin=0

if bmax>=90 or bmin<=-90:
	bmax=90
	bmin=-90

dl=lmax-lmin
db=bmax-bmin





step=maxAreaSize/3600		#arcsec to degrees
n_parts_L=int(ceil(dl/step))

n_parts_B=int(ceil(db/step))

subdiv_l=createSubDiv(n_parts_L, lmin, lmax, step)
subdiv_b=createSubDiv(n_parts_B, bmin, bmax, step)	

fparams=open(tmp_path+sep+"params","w")
string=str(lmin)+","+str(lmax)+","+str(bmin)+","+str(bmax)+","+str(n_parts_L)+","+str(n_parts_B)
string2=str(subdiv_l)
string3=str(subdiv_b)
fparams.write(string+"\n")
fparams.write(string2+"\n")
fparams.write(string3+"\n")
fparams.close()		
# split cat2 objects in different files

splitRows(newrows, subdiv_l, subdiv_b, header, tmp_path)


